//
//! Copyright 2021 Alibaba Group Holding Limited.
//!
//! Licensed under the Apache License, Version 2.0 (the "License");
//! you may not use this file except in compliance with the License.
//! You may obtain a copy of the License at
//!
//! http://www.apache.org/licenses/LICENSE-2.0
//!
//! Unless required by applicable law or agreed to in writing, software
//! distributed under the License is distributed on an "AS IS" BASIS,
//! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//! See the License for the specific language governing permissions and
//! limitations under the License.

pub mod graph;
pub mod partitioner;
pub mod read_graph;
pub mod write_graph;

pub use graph::element::{
    Details, DynDetails, Edge, Element, GraphElement, GraphObject, GraphPath, PropKey, PropertyValue,
    Vertex, VertexOrEdge,
};
pub use graph::{read_id, write_id, Direction, QueryParams, ID};
pub use partitioner::Partitioner;
pub use read_graph::{from_fn, get_graph, register_graph, ReadGraph, Statement};
pub use write_graph::WriteGraphProxy;
